//*************************************************
// Utilizzo di un tastierino a matrice 4x4
// www.settorezero.com
//
// modulo: settings.h
// autore: Bernardo Giovanni
// data: 13/06/10
// picmicro: PIC16F877A
// clock: 20MHz
//
//*************************************************

/* tastierino numerico collegato su PORTB
uso un tastierino 4x4 (16 pulsanti)
Per comodit ho collegato il tastierino in questo modo
(C=colonna R=riga)
R1 = RB1
R2 = RB3
R3 = RB5
R4 = RB7
C1 = RB0
C2 = RB2
C3 = RB4
C4 = RB6
I pin di riga saranno input ed attiveremo le resistenze di pullup interne
i pin di colonna saranno output e messi a 1 di default
*/

#define BUZZER	RC0 // cicalino
#define LCDBL	RC1 // backlight LCD

unsigned char lcdXpos=0; // posizione colonna attuale
unsigned char lcdYpos=0; // posizione riga attuale
#define MAX_X 16 // numero di colonne del display
#define MAX_Y 2 // numero di righe del display

unsigned char colMask[]=
	{
	0b11111110, // Colonna 1 => RB0 a massa
	0b11111011, // Colonna 2 => RB2 a massa
	0b11101111, // Colonna 3 => RB4 a massa
	0b10111111 // Colonna 4 => RB6 a massa
	};
unsigned char colScan=0; // va da 0 a 3 per scansionare l'array colMask

unsigned char rowMask[]=
	{
	0b00000010, // Riga 1
	0b00001000, // Riga 2
	0b00100000, // Riga 3
	0b10000000 // Riga 4
	};
unsigned char rowScan=0;

unsigned char keys[]={'1','4','7','*','2','5','8','0','3','6','9','#','A','B','C','D'};
unsigned char keypressed=0; // peso numerico del pulsante premuto
bit keyok; // flag di pulsante premuto

void settings(void);
extern void main(void);
extern void sound(void);

void settings(void)
	{
	TRISA=0;
	PORTB=0xFF;
	TRISB=0b10101010;
	TRISC=0;
	TRISD=0;
	INTCON=0b00000000;
	RBPU=0; // resistenze di pullup su portb attivate
	}